#include "param.h"

double cost(double x)
{
  return 1-x/(REG+x);
  //return 1.0;
}

float E(void *xp,void *grad, float **svm_proba)
{
  /* array of the image*/
  float *im = (float *)xp;
  float *gd = (float *)grad;
  unsigned int i,j;
  float E=0;
  float label_temp;


  /*compute the energey of the clique */
  for(i=0;i<H;i++)
    for(j=0;j<W;j++) {
      label_temp=im[i*W+j];
      E -= log(svm_proba[(int)label_temp-1][i*W+j]); 
      if(i-1>-1)
	E += ((im[(i-1)*W+j] == label_temp) ? 0 : MY_BETA*cost(gd[(i-1)*W+j]));
      if(i+1<H)
	E += ((im[(i+1)*W+j] == label_temp) ? 0 : MY_BETA*cost(gd[(i+1)*W+j]));
      if(j-1>-1)
	E += ((im[i*W+j-1] == label_temp) ? 0 : MY_BETA*cost(gd[i*W+j-1]));
      if(j+1<W)
	E += ((im[i*W+j+1] == label_temp) ? 0  : MY_BETA*cost(gd[i*W+j+1]));
      if((i-1>-1)&&(j-1>1))
	E += ((im[(i-1)*W+j-1] == label_temp) ? 0 : MY_BETA*cost(gd[(i-1)*W+j-1]));
      if((i-1>-1)&&(j+1<W))
	E += ((im[(i-1)*W+j+1] == label_temp) ? 0 : MY_BETA*cost(gd[(i-1)*W+j+1]));
      if((i+1<H)&&(j-1>1))
	E += ((im[(i+1)*W+j-1] == label_temp) ? 0 : MY_BETA*cost(gd[(i+1)*W+j-1]));
      if((i+1<H)&&(j+1<W))
	E += ((im[(i+1)*W+j+1] == label_temp) ? 0 : MY_BETA*cost(gd[(i+1)*W+j+1]));
    }
  return E;
}
      

float local_energy(void *xp,int i,int j,float label,void* grad,float **svm_proba)
{
  float E=0;
  float *im = (float *)xp;
  float *gd = (float *)grad; 
  E -= log(svm_proba[(int)label-1][i*W+j]);   
  if(i-1>-1)
    E += ((im[(i-1)*W+j] == label) ? 0 : MY_BETA*cost(gd[(i-1)*W+j]));
  if(i+1<H)
    E += ((im[(i+1)*W+j] == label) ? 0 : MY_BETA*cost(gd[(i+1)*W+j]));
  if(j-1>-1)
    E += ((im[i*W+j-1] == label) ? 0 : MY_BETA*cost(gd[i*W+j-1]));
  if(j+1<W)
    E += ((im[i*W+j+1] == label) ? 0  : MY_BETA*cost(gd[i*W+j+1]));
  if((i-1>-1)&&(j-1>1))
    E += ((im[(i-1)*W+j-1] == label) ? 0 : MY_BETA*cost(gd[(i-1)*W+j-1]));
  if((i-1>-1)&&(j+1<W))
    E += ((im[(i-1)*W+j+1] == label) ? 0 : MY_BETA*cost(gd[(i-1)*W+j+1]));
  if((i+1<H)&&(j-1>1))
    E += ((im[(i+1)*W+j-1] == label) ? 0 : MY_BETA*cost(gd[(i+1)*W+j-1]));
  if((i+1<H)&&(j+1<W))
    E += ((im[(i+1)*W+j+1] == label) ? 0 : MY_BETA*cost(gd[(i+1)*W+j+1]));
  return E;
}

  
