#include "param.h"


/** Function that print the training set **/
int print_train_set(float * data)
{
  int i,j,k,nc;

FILE* fp;


fp = fopen(TRAIN2, "rb");

unsigned int AssignMemSize = W * H * sizeof(unsigned int);

unsigned int* train= (unsigned int*) malloc(AssignMemSize);

if (!fread(train, AssignMemSize, 1, fp)) {
		printf("Could not read file '%s'",TRAIN2);
		return 0;
	}
    fclose(fp);	

//  unsigned char* train=Read_pgm(TRAIN);
 char cmd[512];
  

if(train ==NULL)
    printf("Error in opening file in print_train_set()");

  
  for(nc=0;nc<NC;nc++){

    sprintf(cmd,"/tmp/train_class_%d",nc);
    FILE *f=fopen(cmd,"w");
    if(f==NULL)
      printf("Error in creating file in print_train_set()");
    

for(i=0;i<H;i++)
      for(j=0;j<W;j++){
	if(train[i*W+j]<100){
	  if(train[i*W+j]==nc)
	    fprintf(f,"%d ",1);
	  else
	    fprintf(f,"%d ",-1);
	  for(k=0;k<NB;k++)
	    fprintf(f,"%d:%f ",k+1,data[k*W*H+i*W+j]);
	  fprintf(f,"\n");
	}
      }


    fclose(f);

  }



  free(train);
  return 0;
}

/** Function that print the data set **/
int print_data_set(float *data)
{
  int i,j,k;
  FILE *f=fopen("/tmp/data","w");
  if(f ==NULL)
    printf("Error in opening file in print_data_set()");
  for(i=0;i<H;i++)
    for(j=0;j<W;j++){
      fprintf(f,"%d ",1);
      for(k=0;k<NB;k++)
	    fprintf(f,"%d:%f ",k+1,data[k*W*H+i*W+j]);
      fprintf(f,"\n");
    }
  fclose(f);
  return 0;
}

  
/** Functions that trains SVM in  One vs All **/
int train_svm(){
  int i,j,k,nc;
  float val,max;
  char *cmd=malloc(sizeof( char)*256);
  float* gamma=malloc(sizeof(float)*6);
  gamma[0]=0.125;
  gamma[1]=0.250;
  gamma[2]=0.50;
  gamma[3]=1.00;
  gamma[4]=2.00;
  gamma[5]=4.00;
  FILE *f;
  
  
  for(nc=0;nc<NC;nc++){
    printf("Class %d\n",nc+1);
    max=0;
    j=0;
    for(i=0;i<6;i++){
      sprintf(cmd,"/home/yultar/PHD/LIBSVM/libsvm-2.85/svm-train  -g %f -m 500 -v 5 -c %f /tmp/train_class_%d > /tmp/output_svm",gamma[i], 200.0,nc);
      system(cmd); 
      f=fopen("cv","r");
      fscanf(f,"%f",&val);
      fclose(f);
      printf("g = %f => cv = %f\n",gamma[i],val);
      if(val>max){
	max=val;
	j=i;
      }
    }
    printf("Optimal parameter for Class %d: g=%f\n",nc+1,gamma[j]);
    sprintf(cmd,"/home/yultar/PHD/LIBSVM/libsvm-2.85/svm-train  -g %f -m 500 -b 1 -c %f /tmp/train_class_%d model_class_%d > /tmp/output_svm",gamma[j], 200.0,nc,nc);
    system(cmd);
  } 
 // system("rm /tmp/train_class_*");
  free(cmd);
  free(gamma);
  return 1;
}

/**Function that opens results of SVM classification**/
float **probaclassification_svm()
{
  int i,j,nc;
  int ind_Class, currIndex;
  int label=0;
  float tmp;
  char cmd[256];
char str[41];
  char ch[30];
  float *res_image;
  float **res;
  res = malloc(sizeof(float*)*NC);
  for(i=0;i<NC;i++)
    res[i]=malloc(sizeof(float)*W*H);
  
  res_image = malloc(sizeof(float)*W*H);
  FILE *f;
  
  /* 
  for(nc=0;nc<NC;nc++){
     sprintf(cmd,"/home/yultar/PHD/LIBSVM/libsvm-2.85/svm-predict /tmp/data model_class_%d res_temp_%d",nc,nc);
    //sprintf(cmd,"./svm-predict /tmp/data model_class_%d res_temp_%d",nc,nc);
    system(cmd);
  }
  */

int *IIndexes;
IIndexes = malloc(sizeof(int*)*NC);

FILE *fp;
fp = fopen(MAP,"r");
fscanf(fp,"%7s",str);

for (ind_Class = 0; ind_Class < NC; ind_Class++)
   fscanf(fp,"%d", &IIndexes[ind_Class]);


for (i = 0; i < W*H; i++) {
        fscanf(fp,"%d", &label);
        res_image[i] = label;
        for  (ind_Class = 0; ind_Class < NC; ind_Class++)
            {
              fscanf(fp,"%f", &res[IIndexes[ind_Class]-1][i]);
            } // for  (ind_Class = 0; ind_Class < NC; ind_Class++)

    }//for (i = 0; i < W*H; i++) {

fclose(fp);  


  f=fopen("image_classif","w");
  for(i=0;i<W*H;i++){
    
label = (int)res_image[i];

    fprintf(f,"%d\n",label);
  }

  fclose(f);

 convert_hyper_he(res_image,W,H);
 // convert_hyper_he(res_image,W,H);

  system("mv classification.ppm classif_svm.ppm");


free(IIndexes);

  return res;



}

      
/**Function that classifiy the data set**/
float **classification_svm()
{
  int i,j,nc;
  int label=0;
  float tmp;
  char cmd[256];
  char ch[30];
  float *res_image;
  float **res;
  res = malloc(sizeof(float*)*NC);
  for(i=0;i<NC;i++)
    res[i]=malloc(sizeof(float)*W*H);
  
  res_image = malloc(sizeof(float)*W*H);
  FILE *f;
  for(nc=0;nc<NC;nc++){
     sprintf(cmd,"/home/yultar/PHD/LIBSVM/libsvm-2.85/svm-predict /tmp/data model_class_%d res_temp_%d",nc,nc);
    //sprintf(cmd,"./svm-predict /tmp/data model_class_%d res_temp_%d",nc,nc);
    system(cmd);
  }


  
  for(nc=0;nc<NC;nc++){
    sprintf(cmd,"res_temp_%d",nc);
    f = fopen(cmd,"r");
    if(f==NULL)
      printf("Error opening file in classification_SVM()");
    for( i=0;i<W*H;i++){
      fgets(ch,sizeof(ch),f);
      res[nc][i]=atof(ch);
    }
    fclose(f);
  }
  f=fopen("image_classif","w");
  for(i=0;i<W*H;i++){
    tmp=res[0][i];
    label=0;
    for(nc=1;nc<NC;nc++){
      if(tmp<res[nc][i]){
	label = nc;
	tmp   = res[nc][i];
      }
    }
    fprintf(f,"%d\n",label+1);
    res_image[i]=label+1;
  }
  fclose(f);
  system("rm /tmp/data");
  //system("rm res_temp_*");
 // convert_hyper_HIN(res_image,W,H);
  convert_hyper_he(res_image,W,H);
  //convert_toulouse(res_image,W,H);
  //convert_ikonos(res_image,W,H);
  system("mv classification.ppm classif_svm.ppm");
  return res;



}    
    
  


