#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#define alpha 50.0

float* gradiant(float *data,int w,int h, int nb)
{
  int i,j,k;
  float *grad_vec_tp;
  float *grad;
  float dif;
  grad_vec_tp=malloc(sizeof(float)*w*h*nb);
  grad=(float*)calloc(w*h,sizeof(float));
  if(grad==NULL || grad_vec_tp==NULL)
    printf("Memory Allocation Error in gradiant.c");
  
  /* Compute the Vertical gradiant*/
  for(k=0;k<nb;k++)
    for(i=0;i<h;i++)
      for(j=0;j<w;j++){
	dif=0;
	if(i-1>-1)
	  dif +=2* data[k*w*h+(i-1)*w+j];
	if(i+1<h)
	  dif -=2* data[k*w*h+(i+1)*w+j];
	if((i-1>-1)&&(j-1>1))
	  dif += data[k*w*h+(i-1)*w+j-1];
	if((i-1>-1)&&(j+1<w))
	  dif += data[k*w*h+(i-1)*w+j+1];
	if((i+1<h)&&(j-1>1))
	  dif -= data[k*w*h+(i+1)*w+j-1];
	if((i+1<h)&&(j+1<w))
	  dif -= data[k*w*h+(i+1)*w+j+1];
	grad_vec_tp[k*w*h+i*w+j]=fabs(dif);
      }
  for(i=0;i<h;i++)
    for(j=0;j<w;j++){
      dif=0;
      for(k=0;k<nb;k++)
	dif += grad_vec_tp[k*w*h+i*w+j];
      grad[i*w+j]+=dif;
    }
  /* Compute the Horyzontal gradiant*/
  for(k=0;k<nb;k++)
    for(i=0;i<h;i++)
      for(j=0;j<w;j++){
	dif=0;
	if(j-1>-1)
	  dif += 2*data[k*w*h+i*w+j-1];
	if(j+1<w)
	  dif -= 2*data[k*w*h+i*w+j+1];
	if((i-1>-1)&&(j-1>1))
	  dif += data[k*w*h+(i-1)*w+j-1];
	if((i-1>-1)&&(j+1<w))
	  dif -= data[k*w*h+(i-1)*w+j+1];
	if((i+1<h)&&(j-1>1))
	  dif += data[k*w*h+(i+1)*w+j-1];
	if((i+1<h)&&(j+1<w))
	  dif -= data[k*w*h+(i+1)*w+j+1];
	grad_vec_tp[k*w*h+i*w+j]=fabs(dif);
      }
  for(i=0;i<h;i++)
    for(j=0;j<w;j++){
      dif=0;
      for(k=0;k<nb;k++)
	dif += grad_vec_tp[k*w*h+i*w+j];
      grad[i*w+j]+=dif;
    }
  /* Compute the NOSE gradiant*/
  for(k=0;k<nb;k++)
    for(i=0;i<h;i++)
      for(j=0;j<w;j++){
	dif=0;
	if(i-1>-1)
	  dif += data[k*w*h+(i-1)*w+j];
	if(i+1<h)
	  dif -= data[k*w*h+(i+1)*w+j];
	if(j-1>-1)
	  dif += data[k*w*h+i*w+j-1];
	if(j+1<w)
	  dif -= data[k*w*h+i*w+j+1];
	if((i-1>-1)&&(j-1>1))
	  dif += 2*data[k*w*h+(i-1)*w+j-1];
	if((i+1<h)&&(j+1<w))
	  dif -= 2*data[k*w*h+(i+1)*w+j+1];
	grad_vec_tp[k*w*h+i*w+j]=fabs(dif);
      }
  for(i=0;i<h;i++)
    for(j=0;j<w;j++){
      dif=0;
      for(k=0;k<nb;k++)
	dif += grad_vec_tp[k*w*h+i*w+j];
      grad[i*w+j]+=dif;
    }
   /* Compute the NESO gradiant*/
  for(k=0;k<nb;k++)
    for(i=0;i<h;i++)
      for(j=0;j<w;j++){
	dif=0;
	if(i-1>-1)
	  dif -= data[k*w*h+(i-1)*w+j];
	if(i+1<h)
	  dif += data[k*w*h+(i+1)*w+j];
	if(j-1>-1)
	  dif += data[k*w*h+i*w+j-1];
	if(j+1<w)
	  dif -= data[k*w*h+i*w+j+1];
	if((i-1>-1)&&(j+1<w))
	  dif -= 2*data[k*w*h+(i-1)*w+j+1];
	if((i+1<h)&&(j-1>1))
	  dif += 2*data[k*w*h+(i+1)*w+j-1];
	grad_vec_tp[k*w*h+i*w+j]=fabs(dif);
      }
  for(i=0;i<h;i++)
    for(j=0;j<w;j++){
      dif=0;
      for(k=0;k<nb;k++)
	dif += grad_vec_tp[k*w*h+i*w+j];
      grad[i*w+j]+=dif;
      grad[i*w+j]=grad[i*w+j]/4.0;
    }

  free(grad_vec_tp);
  return grad;
}

	
      
      
      
	
	
	
	 
       
