#include "param.h"
unsigned char* Read_pgm(const char * filename)
{
	FILE *fp;
	char pnmline[256];
	unsigned char *buf;
	int sx, sy, maxval, bytes;
	short format;

	if ((fp = fopen(filename, "rb")) == NULL) {
		return NULL;
	}

    fgets(pnmline, 256, fp);
	if ((pnmline[0] != 'P') || ((pnmline[1] != '5') && (pnmline[1] != '6')))
		
        return NULL;

	if (pnmline[1] == '5')
		format = 1;
	else format = 3;

int cou = 1;

    do {

		fgets(pnmline, 256, fp);  // lose any comments 
	} while (pnmline[0] == '#');
	if (sscanf(pnmline, "%d %d", &sx, &sy) != 2)   //!!!!!
{printf("%d %d\n", sx, sy);
		return NULL;}
    do {
		fgets(pnmline, 256, fp);  // more comment lines
	} while (pnmline[0] == '#');
	if (sscanf(pnmline, "%d", &maxval) != 1)
		return NULL;
	if (sx <= 0 || sy <= 0 || maxval != 255)
		return NULL; // only positive width/height, maxval == 255 allowed
	
	// Read bitmap
	buf = malloc(sx*sy*format*sizeof(unsigned char));
	if (buf == NULL) {
		return NULL;
	}
	bytes = fread(buf, 1, sx*sy*format, fp);
	if (bytes != sx*sy*format) {
		free(buf);
		return NULL;
	}

	return buf;
}


int Load_pgm(float *img,const char * filename,int w,int h)
{
	FILE *fp;
	int i,j;
	
	if ((fp = fopen(filename, "wb")) == NULL) {
		return 0;
	}

	fprintf(fp, "P5\n");
	fprintf(fp, "# Generated by MatYeux! 4 you\n");
	fprintf(fp, "%d %d\n", w, h); // Write size
	fprintf(fp, "255\n"); // Write the max of the image
	
	for(i=0;i<h;i++)
	  for(j=0;j<w;j++)
	    fprintf(fp, "%c", (int)img[i*w+j]);
	
	fclose(fp);
	return 1;
}

float* load_file(const char *name,int w, int h, int nb)
{
  int i,nbr;
  FILE *f;
  unsigned short int *im;
  float *data;
  
  // load
  im =malloc(sizeof(unsigned short int)*h*w*nb);
  data= malloc(sizeof(float)*h*w*nb);
  f=fopen(name,"rb");
  if(f==NULL)
    printf("Image not load");
  
  nbr=fread(im,sizeof(unsigned short int),w*h*nb,f);
  if(nbr != w*h*nb)
    printf("nb read do not correspond to the size of he data");
  fclose(f);
  
  for(i=0;i<w*h*nb;i++)
    data[i]=im[i];
  
  free(im);
  return data;  
}
