#ifndef param_h
#define param_h

#include "stdlib.h"
#include "stdio.h"
#include "time.h"
#include "math.h"
#include <gsl/gsl_rng.h>
#include <gsl/gsl_ieee_utils.h>
#include <gsl/gsl_math.h>

/*
#define NAME_DATA "./University_610x340"
#define TRAIN2     "./UPtraining_Linux.has"
#define TEST      "./UPtest_Linux.has"
#define MAP      "./Map_UP.predict128-0125.probas"
#define W 340
#define H 610
#define NB 103
#define NC 9
#define NBL 9
*/

/*
#define NAME_DATA "./Indiana145x145x200_bsq"
#define TRAIN2     "./IN_training_50-15_Lin.has"
#define TEST      "./IN_testing_50-15_Lin.has"
#define MAP      "./MapIN200_50-15.128-C-6.Probas"
#define W 145
#define H 145
#define NB 200
#define NC 16
#define NBL 16
*/


#define NAME_DATA "./HE_560x600x157"
#define TRAIN2     "./Train_HE560x600_Linux.has"
#define TEST      "./Test_HE560x600_Linux.has"
#define MAP      "./Map_HE560x600.100-01.probas"
#define W 600
#define H 560
#define NB 157
#define NC 12
#define NBL 12


/*
#define NAME_DATA "./image_utm25_AvBy10"
#define TRAIN2     "./LINUXtrain.has"
#define TEST      "./LINUXtest.has"
#define MAP      "./25map.1.pr0625-256.probas"
#define W 975
#define H 583
#define NB 25
#define NC 14
#define NBL 14
*/


#define MY_BETA 4.0
#define MY_BETO 1.0
#define REG 200.0
#define TINIT 2
#define K 0.98
#define TRY 1000000
#define PRINT_CONFIG 1

/*Optimization Funcions*/
float E(void *xp,void *grad,float **svm_proba);
float local_energy(void *xp,int i,int j,float label,void *grad,float **svm_proba);
void P(void *xp,double t);
void Save_Label(void *xp);
double metropolis(float *image,float *grad,float **svm_proba);

/*Image Function*/
float * scale(float *data,int w, int h, int nb);
float *gradiant(float *data,int w,int h, int nb);



/*Input-Output Function*/
int Load_pgm(float *img,const char * filename,int w,int h);
unsigned char* Read_pgm(const char * filename);
float* load_file(const char *name,int w, int h, int nb);
int convert_hyper_HIN(float *data,int w,int h);
int convert_hyper_uni(float *data,int w,int h);
int convert_hyper_in(float *data,int w,int h);
int convert_hyper_he(float *data,int w,int h);
int convert_toulouse(float *data,int w,int h);

/*Functions_svm*/
int print_train_set(float * data);
int print_data_set(float *data);
int train_svm();
float **classification_svm();
float **probaclassification_svm();
int confusion(const char *ref,const char *classif, int w, int h, int nc);

#endif


